

### note, I did everything in 2 jupyter notebooks, so in copying them all in 
# file kind of messy with the little time I had, so if you are to run
# if you don't minnd, just reun this sequentially. I will separate the
# 2 jupyter notebooks with a bunch of white space (some functions have the
# same name so it will be messy if you just highlightt everything and run
# at once, sorry!! )

#### different sections of each jupyter notebook begin with a bunch of # signs

# like 

########### TITLE OF SECTION HERE ##############













############### JUPYTER NOTEBOOK 1, TESTING ERROR ESTIMATORS FOR EXAMPLE 1 ################

######## import dependencies ###########3


from numpy import polynomial as poly
from scipy import linalg as la
from scipy.special import legendre as leg
import numpy as np
import matplotlib.pyplot as pt
import os

##### Define Functions #####

# make movies
'''
def make_movie(dat_hd_r):
    import subprocess

    imgname = dat_hd_r
    paths = dat_hd_r.split('/')
    datedir = ''
    for ii in range(len(paths) - 2):
        pn = paths[ii]
        datedir += pn + '/'
    movname = datedir + dat_hd_r.split('/')[-2] + '_MOVIE'

    print(imgname)
    print(movname)
    subprocess.call(['.conda/envs/chaos/bin/ffmpeg', '-i',
                     imgname + '%*.png', '-filter:v', 'setpts=6*PTS',
                     '-vb', '20M', movname + '.mp4', '-vcodec', 'libx264',
                     '-profile:v',
                     'main',
                     '-crf',
                     '1',
                     '-threads',
                     '0', '-r',
                     '100', '-pix_fmt', 'yuv420p'])
'''

# define real function for problem 1
def fx_sol_1(x):
    c2 = (np.exp(4)+6*np.exp(2)+1)/(8*(np.exp(2)+1))
    c1 = c2 + (np.exp(2)+1)**(-1)
    fx = 0.5*x*np.exp(x)+c1*np.exp(x)+c2*np.exp(-x)
    return fx    
 
# define RHS for problem 1
def rhs_1(x):
    gx = np.exp(x)
    return gx

# kernel function for problem 1
def kernel_eval_1(x,y):
    n1 = len(x)
    n2 = len(y)
    K = np.zeros((n1,n2))
    for i in range(n1):
        for j in range(n2):
            K[i,j] = np.abs(x[i]-y[j])
    return K    

# function estimates at arbitrary x for problem 1
def fx_est_1(x,x_gl,W,fy,l):
    K = kernel_eval_1(x,x_gl)
    fx = l*np.dot(K,W).dot(fy) + rhs_1(x)
    return fx

# errors in density for problem 1
def err_est_1(x,x_gl,W,fy,l):
    fx = fx_est_1(x,x_gl,W,fy,l)
    fx_real = fx_sol_1(x)
    err = abs(fx_real - fx)
    return err,fx,fx_real

def err_est_seq_1(x,x_gl1,x_gl2,W_1,W_2,fy_1,fy_2,l):
    fx1 = fx_est_1(x,x_gl1,W_1,fy_1,l)
    fx2 = fx_est_1(x,x_gl2,W_2,fy_2,l)
    fx_real = fx_sol_1(x)
    err_real_1 = abs(fx_real - fx1)
    err_real_2 = abs(fx_real - fx2)
    err = abs(fx2 - fx1)
    return err,err_real_1,err_real_2,fx1,fx2

def quad_operator(x,x_gl,W,fy,l):
    An_fx = fx_est_1(x,x_gl,W,fy,l) - rhs_1(x)
    return An_fx




##### Density Error: Nystrom vs Real dense error plot ###

# fine grid
nn = 100
xn = np.linspace(start=-1,stop=1,num=nn)

dens_err = np.zeros(len(range(5,100,5)))
j = 0
'''
save_dir = '/home/yuch/Documents/Integral_Equations/plots/fx_err_trap/'

if not os.path.exists(save_dir) : os.mkdir(save_dir)
'''
for i in range(5,100,5):   
    
    x = np.linspace(start=-1,stop=1,num=i)
    I = np.eye(len(x))
    K = kernel_eval_1(x,x)
    W = np.diag(2*np.ones(i))
    W[0][0]=1
    W[i-1][i-1]=1
    W = W/2 * (2/(i-1))
    ell = 0.5
    
    A = I-ell*np.dot(K,W)

    # solve system
    b = rhs_1(x)
    fy = la.solve(A,b)

    # compare errors

    err_temp,fx_est,fx_real = err_est_1(xn,x,W,fy,ell)
    dens_err[j] = la.norm(err_temp,2)
    j += 1
    '''
    # save plots 
    pt.plot(xn,err_temp)
    pt.title('Density error for n = ' + '%d'%i)
    pt.xlim((-1,1))
    pt.ylim((0,0.8))
    pt.savefig(save_dir + '%02d.png'%j)
    pt.clf()
    '''

pt.plot(np.linspace(start=5,stop=100,num = len(dens_err)),dens_err)
pt.ylim((0,6))
pt.title('Density error for Trapezoid Rule')
pt.show()
print(dens_err)



###### Quadrature Estimator plot ######

# fine grid
nn = 100
xn = np.linspace(start=-1,stop=1,num=nn)

dens_err = np.zeros(len(range(5,100,5)))
j = 0
for i in range(5,9,1):   
    
    x = np.linspace(start=-1,stop=1,num=i)
    I = np.eye(len(x))
    K = kernel_eval_1(x,x)
    W = np.diag(2*np.ones(i))
    W[0][0]=1
    W[i-1][i-1]=1
    W = W/2 * (2/(i-1))
    ell = 0.5
    
    A = I-ell*np.dot(K,W)

    # solve system
    b = rhs_1(x)
    fy = la.solve(A,b)

    # compare errors

    err_temp,fx_est,fx_real = err_est_1(xn,x,W,fy,ell)
    dens_err[j] = la.norm(err_temp,2)
    j += 1
    
    # save plots 
    pt.plot(xn,err_temp,label = 'n = '+ '%d'%i)
    

pt.title('Density error for n = 5,6,7,8')
pt.legend(loc = 'upper center')
pt.xlim((-1,1))
pt.ylim((0,0.8))
pt.show()



##### Density Error: Nystrom Sequence Differentials  #####

# fine grid
nn = 100
xn = np.linspace(start=-1,stop=1,num=nn)

dens_err = np.zeros(35)
j = 0

for i in range(5,6,1):   
    
    ## GL for i
    
    x1 = np.linspace(start=-1,stop=1,num=i)
    I = np.eye(len(x1))
    K = kernel_eval_1(x1,x1)
    W1 = np.diag(2*np.ones(i))
    W1[0][0]=1
    W1[i-1][i-1]=1
    W1 = W1/2 * (2/(i-1))
    ell = 0.5
    
    A = I-ell*np.dot(K,W1)

    # solve system
    b = rhs_1(x1)
    fy1 = la.solve(A,b)
    

    
    
    
    ## GL for i+1
    x2 = np.linspace(start=-1,stop=1,num=i+1)
    I = np.eye(len(x2))
    K = kernel_eval_1(x2,x2)
    W2 = np.diag(2*np.ones(i+1))
    W2[0][0]=1
    W2[i][i]=1
    W2 = W2/2 * (2/i)
    ell = 0.5

    A = I-ell*np.dot(K,W2)

    # solve system
    b = rhs_1(x2)
    fy2 = la.solve(A,b)

    
    
    
    
    ## Compare sequential erroes

    err_temp,err_temp_real_1,err_temp_real_2,fx_1,fx_2 = err_est_seq_1(xn,x1,x2,W1,W2,fy1,fy2,ell)
    dens_err[j] = la.norm(err_temp,2)
    j += 1
    
    # save plots 
    pt.plot(xn,err_temp,'b')
    pt.plot(xn,err_temp_real_1,'r--',linewidth=0.5)
    pt.plot(xn,err_temp_real_2,'g--',linewidth=0.5)
    pt.title('Density error difference between n = ' + '%d'%i + ' and n = ' + '%d'%(i+1))
    pt.xlim((-1,1))
    pt.ylim((0,0.8))
    pt.legend(['Difference','Real 1','Real 2'], loc = 'upper center')
    
pt.show()




##### Error In Operators #####


# fine grid operator
nn = 101
xf = np.round(np.linspace(start=-1,stop=1,num=nn),6)

I = np.eye(nn)
Kf = kernel_eval_1(xf,xf)
Wf = np.diag(2*np.ones(nn))
Wf[0][0]=1
Wf[nn-1][nn-1]=1
Wf = Wf/2 * (2/(nn-1))
    
    
Af = np.dot(Kf,Wf) # fine operator



# coarse approximation
n = 11
x = np.round(np.linspace(start=-1,stop=1,num=n),6)

ind = np.nonzero(np.in1d(xf,x)) # indices 

I = np.eye(n)
Kn = kernel_eval_1(xf,x) # extend the rows
Wn = np.diag(2*np.ones(n))
Wn[0][0]=1
Wn[n-1][n-1]=1
Wn = Wn/2 * (2/(n-1))
    

An = np.dot(Kn,Wn) # coarse operator
An_f = np.zeros((nn,nn))
An_f.T[ind]=An.T # extend the columns



### one way ###

#Bn vs (I-An inverse)

# correct indices
Bn = np.eye(nn) + np.dot(la.inv((np.eye(nn)-Af)),An_f)
Br = la.inv(np.eye(nn)-An_f)
print(la.norm(Bn-Br))

pt.imshow(abs(Bn-Br))#,vmin=0, vmax=0.8)
pt.colorbar()
pt.show()

# stacked

print(Bn.shape)
print(Bn.T[ind].T.shape)
pt.imshow(abs(Bn.T[ind].T-Br.T[ind].T))
pt.colorbar()
pt.show()

#(I-A inverse) vs (I-An inverse)

Bn2 = la.inv(np.eye(nn)-Af)
pt.imshow(abs(Bn2 - Br))
pt.colorbar()
pt.show()

#stacked

pt.imshow(abs(Bn2.T[ind].T-Br.T[ind].T))
pt.colorbar()
pt.show()

'''    
# other way
Bn = np.eye(nn) + np.dot(la.inv((np.eye(nn)-An_f)),Af)
Br = la.inv(np.eye(nn)-Af)
print(la.norm(Bn-Br))

pt.imshow(abs(Bn-Br),vmin =0, vmax=0.15)
pt.colorbar()
pt.show()
'''





##### Error in Succesive Operators #####

# coarse x2 approximation
nn = 11
xf = np.round(np.linspace(start=-1,stop=1,num=nn),6)

I = np.eye(nn)
Kf = kernel_eval_1(xf,xf) # extend the rows
Wf = np.diag(2*np.ones(nn))
Wf[0][0]=1
Wf[nn-1][nn-1]=1
Wf = Wf/2 * (2/(nn-1))
    
Af = np.dot(Kf,Wf) # coarse x2 operator


# coarse approximation
n = 6
x = np.round(np.linspace(start=-1,stop=1,num=n),6)

ind = np.nonzero(np.in1d(xf,x)) # indices 

I = np.eye(n)
Kn = kernel_eval_1(xf,x) # extend the rows
Wn = np.diag(2*np.ones(n))
Wn[0][0]=1
Wn[n-1][n-1]=1
Wn = Wn/2 * (2/(n-1))
    

An = np.dot(Kn,Wn) # coarse operator
An_f = np.zeros((nn,nn))
An_f[:][ind]=An.T
An_f = An_f.T
#An_f = np.column_stack((An,np.zeros((nn,nn-n)))) # coarse operator extended to fine grid



# one way

#Bn vs (I-An inverse)


Bn = np.eye(nn) + np.dot(la.inv((np.eye(nn)-Af)),An_f)
Br = la.inv(np.eye(nn)-An_f)
print(la.norm(Bn-Br))

pt.imshow(abs(Bn-Br))#,vmin=0, vmax=0.15)
pt.colorbar()
pt.show()
      

# stacked

print(Bn.shape)
print(Bn.T[ind].T.shape)
pt.imshow(abs(Bn.T[ind].T-Br.T[ind].T))
pt.colorbar()
pt.show()


#(I-A inverse) vs (I-An inverse)


Bn2 = la.inv(np.eye(nn)-Af)
pt.imshow(abs(Bn2 - Br),vmin=0, vmax=0.6)
pt.colorbar()
pt.show()

#stacked

pt.imshow(abs(Bn2.T[ind].T-Br.T[ind].T),vmin=0, vmax=0.6)
pt.colorbar()
pt.show()
    

'''    
# other way
Bn = np.eye(nn) + np.dot(la.inv((np.eye(nn)-An_f)),Af)
Br = la.inv(np.eye(nn)-Af)
print(la.norm(Bn-Br))

pt.imshow(abs(Bn-Br))#,vmin =0, vmax=0.15)
pt.colorbar()
pt.show()
'''












































############### JUPYTER NOTEBOOK 2, TESTING ERROR ESTIMATORS FOR EXAMPLE 2 ################

######## import dependencies ###########3

from numpy import polynomial as poly
from scipy import linalg as la
from scipy.special import legendre as leg
import numpy as np
import matplotlib.pyplot as pt
import os




##### Define Functions #####

# define real function for problem 1
def fx_sol_1(x):
    fx = np.exp(-x)
    return fx    
 
# define RHS for problem 1
def rhs_1(x):
    gx = np.exp(-x)-0.5*(np.exp(x+1)-np.exp(-(x+1)))
    return gx

# kernel function for problem 1
def kernel_eval_1(x,y):
    n1 = len(x)
    n2 = len(y)
    K = np.zeros((n1,n2))
    for i in range(n1):
        for j in range(n2):
            K[i,j] = (x[i]+1)*np.exp(-x[i]*y[j])
    return K    

# function estimates at arbitrary x for problem 1
def fx_est_1(x,x_gl,W,fy,l):
    K = kernel_eval_1(x,x_gl)
    fx = l*np.dot(K,W).dot(fy) + rhs_1(x)
    return fx

# errors in density for problem 1
def err_est_1(x,x_gl,W,fy,l):
    fx = fx_est_1(x,x_gl,W,fy,l)
    fx_real = fx_sol_1(x)
    err = abs(fx_real - fx)
    return err,fx,fx_real

def err_est_seq_1(x,x_gl1,x_gl2,W_1,W_2,fy_1,fy_2,l):
    fx1 = fx_est_1(x,x_gl1,W_1,fy_1,l)
    fx2 = fx_est_1(x,x_gl2,W_2,fy_2,l)
    fx_real = fx_sol_1(x)
    err_real_1 = abs(fx_real - fx1)
    err_real_2 = abs(fx_real - fx2)
    err = abs(fx2 - fx1)
    return err,err_real_1,err_real_2,fx1,fx2

def quad_operator(x,x_gl,W,fy,l):
    An_fx = fx_est_1(x,x_gl,W,fy,l) - rhs_1(x)
    return An_fx




##### Density Error: Nystrom vs Real #####

# fine grid
nn = 100
xn = np.linspace(start=-1,stop=1,num=nn)

dens_err = np.zeros(len(range(5,100,5)))
j = 0

for i in range(5,100,5):       
    
    '''    
    [x,w] = poly.legendre.leggauss(i)

    I = np.eye(len(x))
    K = kernel_eval_1(x,x)  
    W = np.diag(w)
    ell = 0.5
    '''
    # trapezoid quadrature
    x = np.linspace(start=-1,stop=1,num=i)
    I = np.eye(len(x))
    K = kernel_eval_1(x,x)
    W = np.diag(2*np.ones(i))
    W[0][0]=1
    W[i-1][i-1]=1
    W = W/2 * (2/(i-1))
    ell = 0.5
    A = I-ell*np.dot(K,W)

    # solve system
    b = rhs_1(x)
    fy = la.solve(A,b)

    # compare errors

    err_temp,fx_est,fx_real = err_est_1(xn,x,W,fy,ell)
    dens_err[j] = la.norm(err_temp,2)
    j += 1
    
pt.plot(np.linspace(start=5,stop=100,num = len(dens_err)),dens_err)
pt.ylim((0,12))
pt.title('Density error for Trapezoid Rule')
pt.show()
print(dens_err)




##### Quadrature Estimator plot ###3#


# fine grid
nn = 100
xn = np.linspace(start=-1,stop=1,num=nn)

dens_err = np.zeros(len(range(5,100,5)))
j = 0
for i in range(5,9,1):   
    
    x = np.linspace(start=-1,stop=1,num=i)
    I = np.eye(len(x))
    K = kernel_eval_1(x,x)
    W = np.diag(2*np.ones(i))
    W[0][0]=1
    W[i-1][i-1]=1
    W = W/2 * (2/(i-1))
    ell = 0.5
    
    A = I-ell*np.dot(K,W)

    # solve system
    b = rhs_1(x)
    fy = la.solve(A,b)

    # compare errors

    err_temp,fx_est,fx_real = err_est_1(xn,x,W,fy,ell)
    dens_err[j] = la.norm(err_temp,2)
    j += 1
    
    # save plots 
    pt.plot(xn,err_temp,label = 'n = '+ '%d'%i)
    

pt.title('Density error for n = 5,6,7,8')
pt.legend(loc = 'upper center')
pt.xlim((-1,1))
pt.ylim((0,2))
pt.show()



##### Density Error: Nystrom Sequence Differentials  #####

# fine grid
nn = 100
xn = np.linspace(start=-1,stop=1,num=nn)

dens_err = np.zeros(35)
j = 0

for i in range(5,6,1):   
    
    ## trapezoid for i
    
    x1 = np.linspace(start=-1,stop=1,num=i)
    I = np.eye(len(x1))
    K = kernel_eval_1(x1,x1)
    W1 = np.diag(2*np.ones(i))
    W1[0][0]=1
    W1[i-1][i-1]=1
    W1 = W1/2 * (2/(i-1))
    ell = 0.5
    
    A = I-ell*np.dot(K,W1)

    # solve system
    b = rhs_1(x1)
    fy1 = la.solve(A,b)
    

    
    
    
    ## trapezoid for i+1
    x2 = np.linspace(start=-1,stop=1,num=i+1)
    I = np.eye(len(x2))
    K = kernel_eval_1(x2,x2)
    W2 = np.diag(2*np.ones(i+1))
    W2[0][0]=1
    W2[i][i]=1
    W2 = W2/2 * (2/i)
    ell = 0.5

    A = I-ell*np.dot(K,W2)

    # solve system
    b = rhs_1(x2)
    fy2 = la.solve(A,b)

    
    
    
    
    ## Compare sequential erroes

    err_temp,err_temp_real_1,err_temp_real_2,fx_1,fx_2 = err_est_seq_1(xn,x1,x2,W1,W2,fy1,fy2,ell)
    dens_err[j] = la.norm(err_temp,2)
    j += 1
    
    # save plots 
    pt.plot(xn,err_temp,'b')
    pt.plot(xn,err_temp_real_1,'r--',linewidth=0.5)
    pt.plot(xn,err_temp_real_2,'g--',linewidth=0.5)
    pt.title('Density error difference between n = ' + '%d'%i + ' and n = ' + '%d'%(i+1))
    pt.xlim((-1,1))
    pt.ylim((0,2))
    pt.legend(['Difference','Real 1','Real 2'], loc = 'upper center')
    
pt.show()





##### Error In Operators #####


# fine grid operator
nn = 101
xf = np.round(np.linspace(start=-1,stop=1,num=nn),6)

I = np.eye(nn)
Kf = kernel_eval_1(xf,xf)
Wf = np.diag(2*np.ones(nn))
Wf[0][0]=1
Wf[nn-1][nn-1]=1
Wf = Wf/2 * (2/(nn-1))
    
    
Af = np.dot(Kf,Wf) # fine operator



# coarse approximation
n = 11
x = np.round(np.linspace(start=-1,stop=1,num=n),6)

ind = np.nonzero(np.in1d(xf,x)) # indices 

I = np.eye(n)
Kn = kernel_eval_1(xf,x) # extend the rows
Wn = np.diag(2*np.ones(n))
Wn[0][0]=1
Wn[n-1][n-1]=1
Wn = Wn/2 * (2/(n-1))
    

An = np.dot(Kn,Wn) # coarse operator
An_f = np.zeros((nn,nn))
An_f.T[ind]=An.T # extend the columns



### one way ###

#Bn vs (I-An inverse)

# correct indices
Bn = np.eye(nn) + np.dot(la.inv((np.eye(nn)-Af)),An_f)
Br = la.inv(np.eye(nn)-An_f)
print(la.norm(Bn-Br))

pt.imshow(abs(Bn-Br))#,vmin=0, vmax=0.8)
pt.colorbar()
pt.show()

# stacked

print(Bn.shape)
print(Bn.T[ind].T.shape)
pt.imshow(abs(Bn.T[ind].T-Br.T[ind].T))
pt.colorbar()
pt.show()

#(I-A inverse) vs (I-An inverse)

Bn2 = la.inv(np.eye(nn)-Af)
pt.imshow(abs(Bn2 - Br))
pt.colorbar()
pt.show()

#stacked

pt.imshow(abs(Bn2.T[ind].T-Br.T[ind].T))
pt.colorbar()
pt.show()

'''    
# other way
Bn = np.eye(nn) + np.dot(la.inv((np.eye(nn)-An_f)),Af)
Br = la.inv(np.eye(nn)-Af)
print(la.norm(Bn-Br))

pt.imshow(abs(Bn-Br),vmin =0, vmax=0.15)
pt.colorbar()
pt.show()
'''



##### Error in Succesive Operators #####

# coarse x2 approximation
nn = 11
xf = np.round(np.linspace(start=-1,stop=1,num=nn),6)

I = np.eye(nn)
Kf = kernel_eval_1(xf,xf) # extend the rows
Wf = np.diag(2*np.ones(nn))
Wf[0][0]=1
Wf[nn-1][nn-1]=1
Wf = Wf/2 * (2/(nn-1))
    
Af = np.dot(Kf,Wf) # coarse x2 operator


# coarse approximation
n = 6
x = np.round(np.linspace(start=-1,stop=1,num=n),6)

ind = np.nonzero(np.in1d(xf,x)) # indices 

I = np.eye(n)
Kn = kernel_eval_1(xf,x) # extend the rows
Wn = np.diag(2*np.ones(n))
Wn[0][0]=1
Wn[n-1][n-1]=1
Wn = Wn/2 * (2/(n-1))
    

An = np.dot(Kn,Wn) # coarse operator
An_f = np.zeros((nn,nn))
An_f[:][ind]=An.T
An_f = An_f.T
#An_f = np.column_stack((An,np.zeros((nn,nn-n)))) # coarse operator extended to fine grid



# one way

#Bn vs (I-An inverse)


Bn = np.eye(nn) + np.dot(la.inv((np.eye(nn)-Af)),An_f)
Br = la.inv(np.eye(nn)-An_f)
print(la.norm(Bn-Br))

pt.imshow(abs(Bn-Br))#,vmin=0, vmax=0.15)
pt.colorbar()
pt.show()
      

# stacked

print(Bn.shape)
print(Bn.T[ind].T.shape)
pt.imshow(abs(Bn.T[ind].T-Br.T[ind].T))
pt.colorbar()
pt.show()


#(I-A inverse) vs (I-An inverse)


Bn2 = la.inv(np.eye(nn)-Af)
pt.imshow(abs(Bn2 - Br),vmin=0, vmax=0.37)
pt.colorbar()
pt.show()

#stacked

pt.imshow(abs(Bn2.T[ind].T-Br.T[ind].T),vmin=0, vmax=0.37)
pt.colorbar()
pt.show()
    

'''    
# other way
Bn = np.eye(nn) + np.dot(la.inv((np.eye(nn)-An_f)),Af)
Br = la.inv(np.eye(nn)-Af)
print(la.norm(Bn-Br))

pt.imshow(abs(Bn-Br))#,vmin =0, vmax=0.15)
pt.colorbar()
pt.show()
'''




